## eliom 3.0.3

=== Makefile ===
include Makefile.config

### Building

.PHONY: all byte opt doc

all:
	${MAKE} -C src all

byte:
	${MAKE} -C src byte

opt:
	${MAKE} -C src opt

odoc:
	$(MAKE) -C src odoc

doc:
	$(MAKE) -C doc doc

### Testing ###

.PHONY: run.local run.opt.local top

run.local: tests.byte fifo
	ocsigenserver -c local/etc/${PROJECTNAME}.conf

tests.byte: byte
	${MAKE} -C tests byte

run.opt.local: tests.opt fifo
	ocsigenserver.opt -c local/etc/${PROJECTNAME}.conf

tests.opt: opt
	${MAKE} -C tests opt

fifo:
	[ -p local/var/run/${PROJECTNAME}_command ] || \
	 { mkfifo local/var/run/${PROJECTNAME}_command; \
	   chmod 660 local/var/run/${PROJECTNAME}_command; }


### Cleaning ###

clean: clean.local
	${MAKE} -C src clean
	${MAKE} -C tests clean

clean.local:
	-rm -f $(PROJECTNAME)-*.tar.gz

distclean: clean.local
	${MAKE} -C src distclean
	${MAKE} -C tests distclean
	-${MAKE} -C doc clean
	-rm Makefile.config
	-rm -f *~ \#* .\#*

### Installation ####

.PHONY: install uninstall reinstall

install:
	$(MAKE) -C src install
	@echo
	@echo "## Run \"make doc\" and \"make install.doc\" to build and install the ocamldoc."
install.byte:
	$(MAKE) -C src install.byte
install.opt:
	$(MAKE) -C src install.opt

uninstall:
	-$(MAKE) -C src uninstall

reinstall:
	$(MAKE) -C src reinstall
reinstall.byte:
	$(MAKE) -C src reinstall.byte
reinstall.opt:
	$(MAKE) -C src reinstall.opt

install.doc:
	${MAKE} -C doc install

###

.PHONY: dist

VERSION := $(shell head -n 1 VERSION)
dist:
	DARCS_REPO=$(PWD) darcs dist -d $(PROJECTNAME)-$(VERSION)

###

.PHONY: depend
depend:
	${MAKE} -C src/syntax
	${MAKE} -C src/tools
	${MAKE} -C src files/META.${PROJECTNAME} depend
	${MAKE} -C tests depend

=== doc/Makefile ===

doc: server.doc client.doc
server.doc:
	${MAKE} -C server doc
client.doc:
	${MAKE} -C client doc

clean:
	${MAKE} -C server clean
	${MAKE} -C client clean
	-rm -f *~ \#* .\#*

install:
	${MAKE} -C server install
	${MAKE} -C client install

=== src/Makefile ===
include ../Makefile.config

all: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server all
	${MAKE} -C client all
	${MAKE} -C tools all

byte: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server byte
	${MAKE} -C client all
	${MAKE} -C tools all

opt: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server opt
	${MAKE} -C client all
	${MAKE} -C tools all

odoc:
	${MAKE} -C server odoc DEPEND=no
	${MAKE} -C client odoc DEPEND=no

clean:
	${MAKE} -C server clean DEPEND=no
	${MAKE} -C client clean DEPEND=no
	${MAKE} -C tools clean
	${MAKE} -C syntax clean
	-rm -f files/META  files/META.${PROJECTNAME}
	-rm -f ../local/etc/$(PROJECTNAME).conf

distclean:
	${MAKE} -C server distclean DEPEND=no
	${MAKE} -C client distclean DEPEND=no
	${MAKE} -C tools distclean
	${MAKE} -C syntax distclean
	-rm -f *~ \#* .\#*

depend: syntax.depend server.depend client.depend tools.depend
syntax.depend:
	${MAKE} -C syntax depend pa_include.cmo
server.depend: syntax.depend
	find server -name .\*.deps -delete
	rm -f server/.depend
	 ${MAKE} -C server .depend
client.depend: syntax.depend
	find client -name .\*.deps -delete
	rm -f client/.depend
	${MAKE} -C client .depend
tools.depend: syntax.depend
	${MAKE} -C tools depend

VERSION := $(shell head -n 1 ../VERSION)

install: install.META install.man
	${MAKE} -C server install
	${MAKE} -C client install
	${MAKE} -C syntax install
	${MAKE} -C tools install

install.man: install.META
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man1
	$(INSTALL) -m 755 files/eliomc.1 $(TEMPROOT)$(MANDIR)/man1
	$(INSTALL) -m 755 files/eliom-destillery.1 $(TEMPROOT)$(MANDIR)/man1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/js_of_eliom.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomopt.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomcp.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomdep.1

install.META:
	${OCAMLFIND} install ${PROJECTNAME} \
	   -destdir $(TEMPROOT)${LIBDIR} \
	   -patch-version ${VERSION} \
	   files/META

install.byte: install.META install.man
	${MAKE} -C server install.byte
	${MAKE} -C client install
	${MAKE} -C syntax install
	${MAKE} -C tools install

install.opt: install.META install.man
	${MAKE} -C server install.opt
	${MAKE} -C client install
	${MAKE} -C syntax install
	${MAKE} -C tools install

uninstall:
	${MAKE} -C server uninstall
	${MAKE} -C client uninstall
	${MAKE} -C syntax uninstall
	${MAKE} -C tools uninstall
	${OCAMLFIND} remove ${PROJECTNAME} \
	   -destdir $(TEMPROOT)${LIBDIR}
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomc.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/js_of_eliom.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomopt.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomcp.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomdep.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliom-destillery.1

reinstall: uninstall install
reinstall.byte: uninstall install.byte
reinstall.opt: uninstall install.opt

metas: files/META files/META.${PROJECTNAME}

SED_META := -e s/%%NAME%%/$(PROJECTNAME)/g \
	    -e s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	    -e s/%%CDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${CLIENT_PACKAGE})/g \
	    -e s/%%SDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_SYNTAX})/g \
	    -e s/%%CSDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${CLIENT_SYNTAX})/g \

files/META: files/META.in ../Makefile.config  ../Makefile.options Makefile
	sed ${SED_META} $< > $@

files/META.${PROJECTNAME}: files/META.in ../Makefile.config  ../Makefile.options Makefile
	echo "directory = \"..\"" > $@
	sed ${SED_META} $< >> $@

conf: ../local/etc/$(PROJECTNAME).conf

CONF_SED := -e s%_LOGDIR_%$(SRC)/local/var/log%g
CONF_SED += -e s%_DATADIR_%$(SRC)/local/var/lib%g
CONF_SED += -e s%\<user\>_OCSIGENUSER_\</user\>%%g
CONF_SED += -e s%\<group\>_OCSIGENGROUP_\</group\>%\<debugmode/\>%g
CONF_SED += -e s%_COMMANDPIPE_%$(SRC)/local/var/run/${PROJECTNAME}_command%g
CONF_SED += -e s%_MIMEFILE_%$(SRC)/src/files/mime.types%g
CONF_SED += -e "s%_METADIR_%$(addsuffix \"/\>\\n    \<findlib path=\",$(shell ocamlfind printconf path))$(SRC)/src/files/%g" -e s%path=\"\ %path=\"%g
CONF_SED += -e s%_OCSDIR_%$(shell ${OCAMLFIND} query ocsigenserver)%g
CONF_SED += -e s%_OCSEXTDIR_%$(shell ${OCAMLFIND} query ocsigenserver.ext)%g
CONF_SED += -e s%_PROJECTNAME_%$(PROJECTNAME)%g
CONF_SED += -e s%_CONFIGDIR_%$(SRC)/local/etc%g
CONF_SED += -e s%_STATICPAGESDIR_%$(SRC)/local/var/www%g
CONF_SED += -e s%_LOCALDIR_%$(SRC)/local%g
CONF_SED += -e s%store\ dir=\"$(SRC)/var/lib\"%store\ dir=\"$(SRC)/local/var/lib/ocsipersist\"%g

../local/etc/$(PROJECTNAME).conf: files/${PROJECTNAME}.conf.in ../Makefile.config Makefile
	cat $< | sed ${CONF_SED}  > $@

=== tests/Makefile ===
include ../Makefile.config

## Use local files
## (tests do not require global installation of Eliom)
export OCAMLPATH := ${SRC}/src/files:${OCAMLPATH}
export PATH := ${SRC}/src/tools:${PATH}
export ELIOM_DATA_DIR := ${SRC}/src/files

ifeq "${DEBUG}" "YES"
  DEBUG_OPTION := -g
else
  DEBUG_OPTION :=
endif

ELIOMC   := eliomc -I ${SRC}/src/server/extensions ${DEBUG_OPTION}
ELIOMOPT := eliomopt -I ${SRC}/src/server/extensions ${DEBUG_OPTION}
ELIOMDEP := eliomdep -I ${SRC}/src/server/extensions
JS_OF_ELIOM := js_of_eliom ${DEBUG_OPTION}

ifeq "${NATDYNLINK}" "YES"
all: byte opt
else
all: byte
endif

#### Main site : eliom_testsuite ####

SERVER_PACKAGE :=
CLIENT_PACKAGE :=

SERVER_FILES := eliom_testsuite_base.eliom \
                eliom_testsuite1.ml \
                eliom_testsuite2.ml \
                eliom_testsuite3.eliom \
                eliom_testsuite4.eliom \
		eliom_testsuite.ml     \
                atom_example.ml \

CLIENT_FILES := eliom_testsuite_base.eliom \
                eliom_testsuite3.eliom \
                eliom_testsuite4.eliom

OTHER_FILES := eliom_testsuite_global.eliom eliom_testsuite_site.eliom

STATICDIR := ../local/var/www/tests
TYPE_DIR =

DESTILLERY_FILES := $(addprefix $(STATICDIR)/destillery/basic/,test.cma test.cmxa test.js)

byte:: _server/eliom_testsuite_global.cmo _server/eliom_testsuite_site.cmo eliom_testsuite.cma ${STATICDIR}/eliom_testsuite.js destillery-basic-byte
opt:: _server/eliom_testsuite_global.cmxs _server/eliom_testsuite_site.cmxs eliom_testsuite.cmxs ${STATICDIR}/eliom_testsuite.js destillery-basic-opt

#### Destillery ####

.PHONY: destillery-basic-byte destillery-basic-opt

destillery/basic:
	mkdir -p $@
	eliom-destillery -name destillery_basic -destination $@
	echo 'PREFIX=$(CURDIR)/../local/' >> $@/Makefile.options
	echo 'STATICDIR=var/www/destillery-basic/static' >> $@/Makefile.options
	echo 'ELIOMSTATICDIR=var/www/destillery-basic/eliomstatic' >> $@/Makefile.options
	echo 'LIBDIR=var/www/destillery-basic/lib' >> $@/Makefile.options
	echo 'WWWUSER=' >> $@/Makefile.options
	echo 'WWWGROUP=' >> $@/Makefile.options
	make -C $@ byte install.static
destillery-basic-byte: | destillery/basic
	make -C destillery/basic byte install.lib.byte
destillery-basic-opt: | destillery/basic
	make -C destillery/basic opt install.lib.opt

#### Server side #######

SERVER_INC  := ${addprefix -package ,${SERVER_PACKAGE}}

SERVER_OBJS := $(patsubst %.eliom,_server/%.cmo, \
	          $(patsubst %.ml,_server/%.cmo,${SERVER_FILES}))

eliom_testsuite.cma: ${SERVER_OBJS}
	${ELIOMC} -a -o $@ $^
eliom_testsuite.cmxa: ${SERVER_OBJS:.cmo=.cmx}
	${ELIOMOPT} -a -o $@ $^

${or ${TYPE_DIR},_server}/%.type_mli: %.eliom
	${ELIOMC} -infer ${SERVER_INC} -o $@ $<

_server/%.cmi: %.mli
	${ELIOMC} -c ${SERVER_INC} $<

_server/%.cmo: %.ml
	${ELIOMC} -c ${SERVER_INC} $<
_server/%.cmo: %.eliom
	${ELIOMC} -c ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_INC} $<

_server/%.cmx: %.ml
	${ELIOMOPT} -c ${SERVER_INC} $<
_server/%.cmx: %.eliom
	${ELIOMOPT} -c ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_INC} $<

%.cmxs: %.cmxa
	$(ELIOMOPT) -shared -linkall -o $@ $<

%.cmxs: %.cmx
	$(ELIOMOPT) -shared -linkall -o $@ $<

##### Client side ####

CLIENT_LIBS := ${addprefix -package ,${CLIENT_PACKAGE}}
CLIENT_INC  := ${addprefix -package ,${CLIENT_PACKAGE}}

CLIENT_OBJS := $(patsubst %.eliom,_client/%.cmo, \
	          $(patsubst %.ml,_client/%.cmo,${CLIENT_FILES}))

${STATICDIR}/eliom_testsuite.js:  ${CLIENT_OBJS}
	${JS_OF_ELIOM} -o $@ -jsopt -pretty -jsopt -noinline ${CLIENT_LIBS} $^

_client/%.cmi: %.mli
	${JS_OF_ELIOM} -c ${CLIENT_INC} $<

_client/%.cmo: %.eliom
	${JS_OF_ELIOM} -c ${addprefix -type-dir ,${TYPE_DIR}} ${CLIENT_INC} $<
_client/%.cmo: %.ml
	${JS_OF_ELIOM} -c ${CLIENT_INC} $<

####### Aux site: miniwiki #######

byte:: miniwiki.byte
opt:: miniwiki.opt

miniwiki.byte:
	$(MAKE) --no-print-directory -C miniwiki byte

miniwiki.opt:
	$(MAKE) --no-print-directory -C miniwiki opt

############

## Clean up

clean: clean.local
	${MAKE} -C miniwiki clean
clean.local:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${or ${TYPE_DIR},_server}/*.type_mli
	-rm -f ${STATICDIR}/eliom_testsuite.js
	-rm -rf _client/* _server/*
	-rm -rf destillery

distclean: clean.local
	-rm -f *~ \#* .\#*
	${MAKE} -C distclean
	${MAKE} -C miniwiki distclean

## Dependencies

depend:
	${MAKE} -C miniwiki depend
	$(ELIOMDEP) -server ${SERVER_INC} ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_FILES} ${OTHER_FILES} > .depend
	$(ELIOMDEP) -client ${CLIENT_INC} ${addprefix -type-dir ,${TYPE_DIR}} ${CLIENT_FILES} $(OTHER_FILES) >> .depend

include .depend

## TODO

# %.wiki: %.ml
# cat $< | sed '1,/(\*wiki\*/d' | sed '/%<||2>%/,$$ d' | /bin/sh ./tutomake.sh > $@

=== doc/client/Makefile ===
include ../../Makefile.config
include ../../src/client/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

ODOC := $(addprefix ../../src/client/,$(DOC:.mli=.odoc))

doc: odoc api-html/index.html api-man/Eliom_lib.client.3o
wikidoc: odoc api-wiki/index.wiki

odoc:
	${MAKE} -C ../../src/client odoc

api-html/index.html: indexdoc ${ODOC}
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc $(addprefix -load ,${ODOC}) -html

api-man/Eliom_lib.client.3o: ${ODOC}
	mkdir -p api-man
	$(OCAMLDOC) ${LIBS} -d api-man -man-mini $(addprefix -load ,${ODOC}) -man \
	  -man-section 3o -man-suffix client.3o

api-wiki/index.wiki: indexdoc ${ODOC}
	mkdir -p api-wiki
	ODOC_WIKI_SUBPROJECT=client $(OCAMLDOC) -d api-wiki -intro indexdoc \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   -colorize-code $(addprefix -load ,${ODOC})

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)/client
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)/client
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man3
	$(INSTALL) -m 755 api-man/* $(TEMPROOT)$(MANDIR)/man3

clean:
	-rm -f api-html/*
	-rm -f api-man/*
	-rm -f api-wiki/*
	-rm -f *~ \#* .\#*
	-rm -rf ${TMP}

=== doc/server/Makefile ===
include ../../Makefile.config
include ../../src/server/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

ODOC := $(addprefix ../../src/server/,$(DOC:.mli=.odoc))

doc: odoc api-html/index.html api-man/Eliom_lib.server.3o
wikidoc: odoc api-wiki/index.wiki

odoc:
	${MAKE} -C ../../src/server odoc

api-html/index.html: indexdoc ${ODOC}
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc $(addprefix -load ,${ODOC}) -html

api-man/Eliom_lib.server.3o: ${ODOC}
	mkdir -p api-man
	$(OCAMLDOC) ${LIBS} -d api-man -man-mini $(addprefix -load ,${ODOC}) -man \
	  -man-section 3o -man-suffix server.3o

api-wiki/index.wiki: indexdoc ${ODOC}
	mkdir -p api-wiki
	ODOC_WIKI_SUBPROJECT=server $(OCAMLDOC) -d api-wiki -intro indexdoc \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   -colorize-code $(addprefix -load ,${ODOC})

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)/server
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)/server
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man3
	$(INSTALL) -m 755 api-man/* $(TEMPROOT)$(MANDIR)/man3

clean:
	-rm -f api-html/*
	-rm -f api-man/*
	-rm -f api-wiki/*
	-rm -f *~ \#* .\#*

=== src/client/Makefile ===
include ../../Makefile.config

LIBS     := -I private ${addprefix -package ,${CLIENT_PACKAGE} ${CLIENT_SYNTAX}} \
	    -ppopt ../syntax/pa_include.cmo

OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep
OCAMLDOC := ${OCAMLFIND} ocamldoc -ppopt o -ppopt -printer

all: eliom_client.cma eliom_client_main.cmo

### Common files ###

COMMON_FILES  := $(notdir $(wildcard ../common/*.mli) $(wildcard ../common/*.ml))
COMMON_PFILES := $(addprefix private/, \
		     $(notdir $(wildcard ../common/private/*.mli) \
	                      $(wildcard ../common/private/*.ml)))
COMMON_SFILES := $(addprefix sigs/, \
		     $(notdir $(wildcard ../common/sigs/*.mli) \
	                      $(wildcard ../common/sigs/*.ml)))

PREDEP := ${COMMON_FILES} ${COMMON_PFILES} ${COMMON_SFILES}

.SECONDARY: ${PREDEP}
${COMMON_FILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -s $< $@
${COMMON_PFILES} ${COMMON_SFILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -s ../$< $@

### Library ###

FILES := private/eliommod_jstable.ml \
	 eliom_config.ml \
	 eliom_unwrap.ml eliom_lazy.ml \
	 eliom_lib_base.ml \
	 eliom_lib.ml \
	 eliom_content_core.ml \
	 eliom_common_base.ml eliom_common.ml \
	 eliom_cookies_base.ml \
         private/eliommod_cookies.ml \
	 eliom_types_base.ml eliom_types.ml \
	 eliom_process.ml \
	 eliom_request_info.ml \
	 eliom_parameter_base.ml eliom_parameter.ml \
	 eliom_service_base.ml eliom_service.ml \
	 eliom_uri.ml \
	 eliom_request.ml \
         private/eliommod_dom.ml \
	 eliom_mkforms.ml eliom_registration_base.ml \
	 eliom_client.ml eliom_content.ml \
	 eliom_registration.ml \
	 eliom_comet_base.ml eliom_comet.ml \
	 eliom_bus.ml \
	 eliom_react.ml \
	 eliom_pervasives_base.ml \
	 eliom_pervasives.ml \
	 eliom_tools.ml \

INTF_NOP4 :=

eliom_client.cma: eliom_client_stubs.o ${FILES:.ml=.cmo}
	${OCAMLMKLIB} -o ${@:.cma=} $^

##########

%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${INTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<

%.odoc: %.mli
	${OCAMLDOC} -syntax camlp4o ${LIBS} -dump ${ODOC_DIR}$@ $<
${INTF_NOP4:.mli=.odoc}: \
%.odoc: %.mli
	${OCAMLDOC} ${LIBS} -dump ${ODOC_DIR}$@ $<

%.cmxs: %.cmx
	$(OCAMLOPT) -shared -linkall -o $@ $<
%.o: %.c
	$(OCAMLC) -c $<




## INSTALL ##

include Makefile.filelist

odoc: ${DOC:.mli=.odoc}

install: ${PREDEP}
	${INSTALL} -m 755 -d ${CLIENTDIR}
	${INSTALL} -m 644 ${INTF} ${IMPL} ${STUBS} ${DOC} ${CLIENTDIR}

uninstall:
	-rm -fr ${CLIENTDIR}

#####

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.deps *.odoc *.so
	-cd private && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc

distclean: clean
	-rm -f *~ \#* .\#*
	-rm -f ${PREDEP}
	-rm -f .*.deps private/.*.deps extensions/.*.deps

##  Manual dependencies for pa_include

eliom_registration.cmi eliom_registration.cmo eliom_registration.cmx eliom_registration.odoc \
eliom_mkforms.cmi eliom_mkforms.odoc: ${COMMON_SFILES} $(wildcard sigs/*.mli)

# Automatic dependencies

ifneq (${DEPEND},no)

## Ugly side effect to force ${PREDEP} creation before dependencies calculation
dummy_var := $(shell $(MAKE) DEPEND=no ${PREDEP} >/dev/null 2>&1)

DEPS := $(patsubst %,.%.deps,${COMMON_FILES}) \
	$(patsubst %,.%.deps,${COMMON_PFILES}) \
	$(patsubst %,.%.deps,$(wildcard *.mli *.ml)) \
        $(patsubst private/%,private/.%.deps,$(wildcard private/*.mli private/*.ml)) \

.SECONDARY: ${DEPS}
.depend: ${DEPS}
	cat $(shell ls .*.deps private/.*.deps) > .depend

.%.ml.deps: %.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
.%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

private/.%.ml.deps: private/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
private/.%.mli.deps: private/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

$(patsubst %.mli,.%.mli.deps,${INTF_NOP4}): .%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} $< > $@

include .depend

endif

=== src/server/Makefile ===
include ../../Makefile.config

LIBS     := -I private -I extensions ${addprefix -package ,${SERVER_PACKAGE} ${SERVER_SYNTAX}} \
	    -ppopt ../syntax/pa_include.cmo
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}  ${THREAD}
OCAMLDEP := $(OCAMLFIND) ocamldep

OCAMLDOC := ${OCAMLFIND} ocamldoc ${THREAD} -ppopt o -ppopt -printer
## WTF -ppopt options must be given in reverse order...

all: byte opt

### Common files ###

COMMON_FILES  := $(notdir $(wildcard ../common/*.mli) $(wildcard ../common/*.ml))
COMMON_PFILES := $(addprefix private/, \
		     $(notdir $(wildcard ../common/private/*.mli) \
	                      $(wildcard ../common/private/*.ml)))
COMMON_SFILES := $(addprefix sigs/, \
		     $(notdir $(wildcard ../common/sigs/*.mli) \
	                      $(wildcard ../common/sigs/*.ml)))

PREDEP := ${COMMON_FILES} ${COMMON_PFILES} ${COMMON_SFILES}

.SECONDARY: ${PREDEP}
${COMMON_FILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -sf $< $@
${COMMON_PFILES} ${COMMON_SFILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -sf ../$< $@

FILES := eliom_wrap.ml eliom_lazy.ml \
         eliom_lib_base.ml eliom_lib.ml \
	 eliom_content_core.ml \
	 eliom_cookies_base.ml \
	 eliom_common_base.ml eliom_common.ml \
	 eliom_request_info.ml \
	 private/eliommod_sessiongroups.ml \
	 eliom_cookie.ml \
	 private/eliommod_cookies.ml \
	 private/eliommod_sersess.ml \
         private/eliommod_datasess.ml \
	 private/eliommod_persess.ml \
	 private/eliommod_gc.ml \
	 private/eliommod_sessexpl.ml \
	 private/eliommod_sessadmin.ml \
	 private/eliommod_timeouts.ml \
	 eliom_state.ml \
	 eliom_reference.ml \
	 eliom_extension.ml \
	 private/eliommod_services.ml \
	 private/eliommod_naservices.ml \
         eliom_types_base.ml eliom_types.ml \
	 eliom_error_pages.ml \
	 private/eliommod_pagegen.ml \
	 private/eliommod.ml \
         eliom_parameter_base.ml eliom_parameter.ml \
	 eliom_process.ml \
	 private/eliommod_cli.ml \
	 eliom_service_base.ml eliom_service.ml \
         eliom_config.ml \
         eliom_uri.ml \
	 eliom_mkforms.ml \
	 eliom_registration_base.ml \
	 eliom_content.ml \
	 eliom_mkreg.ml \
	 eliom_registration.ml \
	 eliom_comet_base.ml eliom_comet.ml  \
         eliom_tools_common.ml \
	 eliom_tools.ml \
	 eliom_react.ml \
	 eliom_bus.ml \
	 extensions/eliom_s2s.ml extensions/eliom_openid.ml \
	 extensions/atom_feed.ml extensions/eliom_atom.ml \
	 eliom_pervasives_base.ml \
	 eliom_pervasives.ml \

	 # eliom_extension_template.ml \

INTF_NOP4 :=

byte:: eliom.cma
opt:: eliom.cmxa
ifeq "${NATDYNLINK}" "YES"
opt:: eliom.cmxs
endif

eliom.cma: ${FILES:.ml=.cmo}
	${OCAMLC} -a -o $@ $^
eliom.cmxa: ${FILES:.ml=.cmx}
	${OCAMLOPT} -a -o $@ $^

##########

%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${INTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<

%.odoc: %.mli
	${OCAMLDOC} -syntax camlp4o ${LIBS} -dump ${ODOC_DIR}$@ $<
${INTF_NOP4:.mli=.odoc}: \
%.odoc: %.mli
	${OCAMLDOC} ${LIBS} -dump ${ODOC_DIR}$@ $<

%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## INSTALL ##

include Makefile.filelist

odoc: ${DOC:.mli=.odoc}

install: INSTALL_IMPL:=${IMPL} ${NATIMPL}
install: raw_install

install.byte: INSTALL_IMPL:=${IMPL}
install.byte: raw_install

install.opt: INSTALL_IMPL:=${NATIMPL}
install.opt: raw_install

raw_install: ${PREDEP}
	${INSTALL} -m 755 -d ${SERVERDIR}
	${INSTALL} -m 644 ${INTF} ${INSTALL_IMPL} ${INTF:.cmi=.mli} ${SERVERDIR}

uninstall:
	-rm -fr ${SERVERDIR}

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc
	-cd private && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc
	-cd extensions && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc
distclean: clean
	-rm -f *~ \#* .\#*
	-rm -f ${PREDEP}
	-rm -f .*.deps private/.*.deps extensions/.*.deps

## Manual dependencies for pa_include.
eliom_registration_base.cmi eliom_registration_base.cmo eliom_registration_base.cmx \
eliom_registration.cmi eliom_registration.cmo eliom_registration.cmx eliom_registration.odoc \
eliom_mkforms.cmi eliom_mkforms.cmo eliom_mkforms.cmx eliom_mkforms.odoc \
eliom_mkreg.cmi eliom_mkreg.odoc: ${COMMON_SFILES} $(wildcard sigs/*.mli)

# Automatic dependencies

ifneq (${DEPEND},no)

## Ugly side effect to force ${PREDEP} creation before dependencies calculation
dummy_var := $(shell $(MAKE) DEPEND=no ${PREDEP} >/tmp/log 2>&1)

DEPS := $(patsubst %,.%.deps,${COMMON_FILES}) \
	$(patsubst %,.%.deps,${COMMON_PFILES}) \
	$(patsubst %,.%.deps,$(wildcard *.mli *.ml)) \
	$(patsubst private/%,private/.%.deps,$(wildcard private/*.mli private/*.ml)) \
	$(patsubst extensions/%,extensions/.%.deps, \
	     $(wildcard extensions/*.mli extensions/*.ml))

.SECONDARY: ${DEPS}
.depend: ${DEPS}
	cat $(shell ls .*.deps private/.*.deps extensions/.*.deps) > .depend

.%.ml.deps: %.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
.%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

private/.%.ml.deps: private/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
private/.%.mli.deps: private/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

extensions/.%.ml.deps: extensions/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
extensions/.%.mli.deps: extensions/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

$(patsubst %.mli,.%.mli.deps,${INTF_NOP4}): .%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} $< > $@

include .depend

endif

=== src/syntax/Makefile ===
include ../../Makefile.config

PACKAGE  := camlp4.quotations.o,camlp4.extend
LIBS := ${addprefix -package ,${PACKAGE}}

OCAMLDEP := $(OCAMLFIND) ocamldep -syntax camlp4o
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} -syntax camlp4o -I +camlp4/Camlp4Parsers

FILES:= pa_eliom_seed.ml          \
	pa_eliom_type_filter.ml   \
	pa_eliom_client_client.ml \
	pa_eliom_client_server.ml \
	pa_include.ml             \

all: $(FILES:.ml=.cmo)

install:
	${INSTALL} -m 755 -d ${SYNTAXDIR}
	${INSTALL} -m 644 ${FILES:.ml=.cmo} ${SYNTAXDIR}

uninstall:
	-rm -fr ${SYNTAXDIR}

%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<

clean:
	-rm -f *.cm[aiox] *.cmxa *.cmxs *.o *.a *~ doc/*  *.annot

distclean: clean
	-rm -f *~ \#* .\#*

depend:
	$(OCAMLDEP) ${LIBS} $(FILES) > .depend

-include .depend

=== src/tools/Makefile ===
include ../../Makefile.config

LIBS     := -package str,unix,findlib
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte

### Common files ###

COMPILER := eliomc eliomcp eliomopt js_of_eliom eliomdep
DESTILLERY := eliom-destillery

FILES := ../../src/files
DESTILLERY_BASIC :=destillery/basic

byte: ${COMPILER} $(DESTILLERY)

config.ml:
	echo "let datadir = \"$(DATADIR)\"" > $@
	echo "let destillery_basic = \"$(DESTILLERY_BASIC)\"" >> $@

$(DESTILLERY): utils.cmo config.cmo destillery.cmo
	$(OCAMLC) -o $@ -linkpkg $(LIBS) $^

eliomc: utils.cmo eliomc.cmo
	${OCAMLC} -o $@ -linkpkg ${LIBS} $^

eliomcp eliomopt js_of_eliom: eliomc
	ln -f $< $@

eliomdep: utils.cmo eliomdep.cmo
	${OCAMLC} -o $@ -linkpkg ${LIBS} $^

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<

## INSTALL ##

install:
	$(INSTALL) -m 755 -d $(TEMPROOT)$(BINDIR)
	${INSTALL} -m 755 ${COMPILER} $(DESTILLERY) $(TEMPROOT)${BINDIR}
	$(INSTALL) -m 755 -d $(TEMPROOT)$(DATADIR)/$(DESTILLERY_BASIC)
	$(INSTALL) -m 644 $(FILES)/$(DESTILLERY_BASIC)/* $(TEMPROOT)$(DATADIR)/$(DESTILLERY_BASIC)
uninstall:
	rm -f $(addprefix ${BINDIR}/,${COMPILER} ${DESTILLERY})
	rm -rf $(DATADIR)

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot config.ml
	-rm -f ${COMPILER}
	-rm -f ${PREDEP}
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.ml *.mli > .depend

FORCE:
-include .depend

=== tests/miniforum/Makefile ===
# Write here all the findlib packages you need, for example:
# PACKAGES= ,extlib,netstring

# Write here all your .ml files, in dependency order (default: all)
FILES=services.ml mylib.ml forum0.ml forum1.ml forum2.ml

CAMLC = ocamlfind ocamlc -g -thread $(LIB)
CAMLOPT = ocamlfind ocamlopt -thread $(LIB)
CAMLDOC = ocamlfind ocamldoc $(LIB)
CAMLDEP = ocamlfind ocamldep
OCSIGENREP = `ocamlfind query ocsigen`
#OCSIGENREP = ../ocsigen/lib
LIB = -package lwt.unix,ocsigen$(PACKAGES) -I $(OCSIGENREP)
# If you use the syntax extension:
# PP = -pp "camlp4o $(OCSIGENREP)/xhtmlsyntax.cma"
# otherwise
PP = 

OBJS = $(FILES:.ml=.cmo)

CMA = v0/site0.cma v1/site1.cma v2/site2.cma

.PHONY: $(CMA)

all: depend $(CMA) install

#$(CMA): $(OBJS)
#	$(CAMLC) -a -o $(CMA) $(OBJS)

v0/site0.cma: 
	$(MAKE) -C v0 site0.cma

v1/site1.cma:  
	$(MAKE) -C v1 site1.cma

v2/site2.cma: 
	$(MAKE) -C v2 site2.cma

install:
	chmod a+r $(CMA)

.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.PHONY: doc

.ml.cmo:
	$(CAMLC) $(PP) -c $<

.mli.cmi:
	$(CAMLC) -c $<
.ml.cmx:
	$(CAMLOPT) $(PP) -c $<

doc:
#	$(CAMLDOC) -d doc -html db.mli

clean:
	-rm -f *.cm[ioxa] *~ $(NAME)
	$(MAKE) -C v0 clean
	$(MAKE) -C v1 clean
	$(MAKE) -C v2 clean

depend:
	$(CAMLDEP) $(PP) $(LIB) $(FILES:.ml=.mli) $(FILES) > .depend
	$(MAKE) -C v0 depend
	$(MAKE) -C v1 depend
	$(MAKE) -C v2 depend


FORCE:

-include .depend

=== tests/miniwiki/Makefile ===
include ../../Makefile.config

## Use local files
## (tests do not require global installation of Eliom)
export OCAMLPATH := ${SRC}/src/files:${OCAMLPATH}
export PATH := ${SRC}/src/tools:${PATH}

LIBS := -I ..

ELIOMC   := eliomc${BYTEDBG}
ELIOMOPT := eliomopt ${OPTDBG}
ELIOMDEP := eliomdep

ifeq "${NATDYNLINK}" "YES"
all: byte opt
else
all: byte
endif

### Library

FILES := miniwiki.ml

byte:: miniwiki.cma
opt:: miniwiki.cmxs

miniwiki.cma: ${FILES:.ml=.cmo}
	${ELIOMC} -a -o $@ $^
miniwiki.cmxa: ${FILES:.ml=.cmx}
	${ELIOMOPT} -a -o $@ $^

############

%.cmi: %.mli
	$(ELIOMC) ${LIBS} -c $<
%.cmo: %.ml
	$(ELIOMC) ${LIBS} -c $<
%.cmx: %.ml
	$(ELIOMOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(ELIOMOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f _server/*

distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend:
	$(ELIOMDEP) -server ${LIBS} *.ml *.mli > .depend

FORCE:
-include .depend

=== debian/changelog ===
eliom (3.0.3-4build2) trusty; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 04 Feb 2014 10:35:39 +0000

eliom (3.0.3-4build1) trusty; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 Jan 2014 14:14:24 +0000

eliom (3.0.3-4) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Dec 2013 13:56:26 +0100

eliom (3.0.3-3) experimental; urgency=low

  * Build-depend on ocaml-findlib >= 1.4 to pick up new native
    architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Nov 2013 19:52:51 +0100

eliom (3.0.3-2) experimental; urgency=low

  * Fix eliom-server doc-base files
  * Compile with OCaml >= 4.01
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Nov 2013 07:51:01 +0100

eliom (3.0.3-1) unstable; urgency=low

  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Fri, 10 May 2013 17:07:21 +0200

eliom (3.0.2-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Dec 2012 07:54:38 +0100

eliom (3.0.1-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Dec 2012 21:36:30 +0100

eliom (3.0.0-2) experimental; urgency=low

  * Put binaries and templates in a separate (new) binary package with
    more precise dependencies

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Dec 2012 12:34:58 +0100

eliom (3.0.0-1) experimental; urgency=low

  * New upstream release
    - OCamlDuce support has been dropped
    - update minimal versions of the Ocsigen stack in Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2012 21:36:15 +0100

=== debian/control ===
Source: eliom
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Stéphane Glondu <glondu@debian.org>,
  Pierre Chambart <pierre.chambart@crans.org>
Build-Depends:
  ocaml-nox (>= 4.01),
  ocaml-findlib (>= 1.4),
  dh-ocaml (>= 0.9~),
  debhelper (>= 8),
  ocsigenserver (>= 2.0.4),
  libocsigenserver-ocaml-dev (>= 2.2),
  libderiving-ocsigen-ocaml-dev (>= 0.3),
  libjs-of-ocaml-dev (>= 1.3.2),
  libcalendar-ocaml-dev (>= 2.03),
  liblwt-ssl-ocaml-dev (>= 2.3.2),
  libreact-ocaml-dev (>= 0.9.2),
  js-of-ocaml (>= 1.3.2),
  libtyxml-ocaml-dev (>= 2.2)
Standards-Version: 3.9.4
Homepage: http://ocsigen.org/eliom
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/eliom.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/eliom.git

Package: eliom
Architecture: any
Depends:
 libeliom-ocaml-dev,
 ocaml-findlib,
 js-of-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libeliom-ocaml-doc
Replaces: libeliom-ocaml-dev (<< 3)
Breaks: libeliom-ocaml-dev (<< 3)
Description: web framework for ocsigenserver (tools)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains command-line tools.

Package: libeliom-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Description: web framework for ocsigenserver (dev libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains the development files needed to use Eliom.

Package: libeliom-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Description: web framework for ocsigenserver (runtime libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains dynamically loadable modules to use with
 Ocsigenserver.

Package: libeliom-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: libeliom-ocaml-dev
Description: web framework for ocsigenserver (documentation)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
MANDIR=$(DESTDIR)/usr/share/man

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

# This should test OCAML_HAVE_OCAMLOPT, but camlp4 usage seems to
# force dynlink...
ifeq ($(OCAML_NATDYNLINK),yes)
  BUILD_TARGET := all
  INSTALL_TARGET := install
else
  BUILD_TARGET := byte
  INSTALL_TARGET := install.byte
endif

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	chmod +x configure
#we must recreate those directories from the tar because git remove
#the empty directories.
	mkdir -p local/etc
	mkdir -p src/client/sigs
	./configure \
	    --prefix /usr \
	    --libdir $(OCAML_STDLIB_DIR) \
	    --temproot $(DESTDIR) \
	    --mandir /usr/share/man/ \

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)
	$(MAKE) doc

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR)
	$(MAKE) $(INSTALL_TARGET) install.doc

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	[ ! -f Makefile.config ] || $(MAKE) distclean

=== debian/watch ===
version=3
opts="uversionmangle=s/-(rc|beta|pre)/~$1/,dversionmangle=s/\+dfsg\d*$//" \
http://ocsigen.org/download/eliom-([0-9].*)\.tar\.gz
